<?php

namespace Modules\Parametros\Services;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class Sup09800MarcasPorFornecedorParaPedidoDeColetaService
{
    
    protected $connection;
	
    public function __construct($environment, $connection) 
    {
        $this->environment = $environment;
        $this->connection = $connection;
    }
    
     /********************
     *      INSERTS      *
     * ******************/
    
    
    public function addMarcaFornecedor($row)
    {
        $param = array(
            "P_CDFORNECED" => $row['CDFORNECED'],
            "P_CDMARCA"    => $row['CDMARCA']
        );
        
        $query = "INSERT INTO MARCFORNPEDCOL (CDFORNECED, CDMARCA)
                    VALUES (:P_CDFORNECED, :P_CDMARCA)";
                    
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function addCadastramentoAutomatico($row)
    {
       
        $param = array(
            "P_CDFORNECED" => $row['P_CDFORNECED'],
            "P_CDMARCA"    => $row['P_CDMARCA']
        );
        
        $query = "INSERT INTO MARCFORNPEDCOL (CDMARCA, CDFORNECED)
                    (SELECT M.CDMARCA, F.CDFORNECED
                       FROM MARCA M, FORNECEDOR F
                      WHERE (INSTR(:P_CDMARCA, M.CDMARCA) > 0 OR (:P_CDMARCA = 'T'))
                        AND (INSTR(:P_CDFORNECED, F.CDFORNECED) > 0 OR (:P_CDFORNECED = 'T'))
                        AND NOT EXISTS (SELECT 1 FROM MARCFORNPEDCOL MF
                 WHERE MF.CDMARCA    = M.CDMARCA
                   AND MF.CDFORNECED = F.CDFORNECED))";
                    
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    }

    
     /********************
     *      DELETES     *
     * ******************/
     
     
    public function deleteMarcaFornecedor($row)
    {
        $param = array(
            "P_CDFORNECED" => $row['CDFORNECED'],
            "P_CDMARCA"    => $row['CDMARCA']
        );
        
        $query = "  DELETE FROM MARCFORNPEDCOL
                    WHERE CDFORNECED = :P_CDFORNECED
                    AND CDMARCA = :P_CDMARCA";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    } 
}